unit schReferenciaGenericaServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, FmtBCD, uROXMLIntf, schReferenciaGenericaClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID__ExisteFilaReferenciaGenericaDelta = '{451243CC-27EC-4D24-BCCF-4A6529D13DAB}';
  RID_InformeRefGenericaDelta = '{2C849E6E-A572-4480-8371-0767BFC76D53}';
  RID_GetProductoDelta = '{1E633156-754C-4296-B146-EB2952CA6084}';
  RID_ReferenciaGenericaDelta = '{E5A5D9F4-735D-4217-A484-35A87F318EAE}';

type
  { I_ExisteFilaReferenciaGenericaDelta }
  I_ExisteFilaReferenciaGenericaDelta = interface(I_ExisteFilaReferenciaGenerica)
  ['{451243CC-27EC-4D24-BCCF-4A6529D13DAB}']
    { Property getters and setters }
    function GetOldNUMINFValue : String;
    function GetOldCLAVE1Value : Float;
    function GetOldCLAVE2Value : Integer;
    function GetOldCLAVE3Value : Integer;
    function GetOldNUMCONValue : Integer;

    { Properties }
    property OldNUMINF : String read GetOldNUMINFValue;
    property OldCLAVE1 : Float read GetOldCLAVE1Value;
    property OldCLAVE2 : Integer read GetOldCLAVE2Value;
    property OldCLAVE3 : Integer read GetOldCLAVE3Value;
    property OldNUMCON : Integer read GetOldNUMCONValue;
  end;

  { T_ExisteFilaReferenciaGenericaBusinessProcessorRules }
  T_ExisteFilaReferenciaGenericaBusinessProcessorRules = class(TDABusinessProcessorRules, I_ExisteFilaReferenciaGenerica, I_ExisteFilaReferenciaGenericaDelta)
  private
  protected
    { Property getters and setters }
    function GetNUMINFValue: String; virtual;
    function GetNUMINFIsNull: Boolean; virtual;
    function GetOldNUMINFValue: String; virtual;
    function GetOldNUMINFIsNull: Boolean; virtual;
    procedure SetNUMINFValue(const aValue: String); virtual;
    procedure SetNUMINFIsNull(const aValue: Boolean); virtual;
    function GetCLAVE1Value: Float; virtual;
    function GetCLAVE1IsNull: Boolean; virtual;
    function GetOldCLAVE1Value: Float; virtual;
    function GetOldCLAVE1IsNull: Boolean; virtual;
    procedure SetCLAVE1Value(const aValue: Float); virtual;
    procedure SetCLAVE1IsNull(const aValue: Boolean); virtual;
    function GetCLAVE2Value: Integer; virtual;
    function GetCLAVE2IsNull: Boolean; virtual;
    function GetOldCLAVE2Value: Integer; virtual;
    function GetOldCLAVE2IsNull: Boolean; virtual;
    procedure SetCLAVE2Value(const aValue: Integer); virtual;
    procedure SetCLAVE2IsNull(const aValue: Boolean); virtual;
    function GetCLAVE3Value: Integer; virtual;
    function GetCLAVE3IsNull: Boolean; virtual;
    function GetOldCLAVE3Value: Integer; virtual;
    function GetOldCLAVE3IsNull: Boolean; virtual;
    procedure SetCLAVE3Value(const aValue: Integer); virtual;
    procedure SetCLAVE3IsNull(const aValue: Boolean); virtual;
    function GetNUMCONValue: Integer; virtual;
    function GetNUMCONIsNull: Boolean; virtual;
    function GetOldNUMCONValue: Integer; virtual;
    function GetOldNUMCONIsNull: Boolean; virtual;
    procedure SetNUMCONValue(const aValue: Integer); virtual;
    procedure SetNUMCONIsNull(const aValue: Boolean); virtual;

    { Properties }
    property NUMINF : String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull : Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property OldNUMINF : String read GetOldNUMINFValue;
    property OldNUMINFIsNull : Boolean read GetOldNUMINFIsNull;
    property CLAVE1 : Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull : Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property OldCLAVE1 : Float read GetOldCLAVE1Value;
    property OldCLAVE1IsNull : Boolean read GetOldCLAVE1IsNull;
    property CLAVE2 : Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull : Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property OldCLAVE2 : Integer read GetOldCLAVE2Value;
    property OldCLAVE2IsNull : Boolean read GetOldCLAVE2IsNull;
    property CLAVE3 : Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull : Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property OldCLAVE3 : Integer read GetOldCLAVE3Value;
    property OldCLAVE3IsNull : Boolean read GetOldCLAVE3IsNull;
    property NUMCON : Integer read GetNUMCONValue write SetNUMCONValue;
    property NUMCONIsNull : Boolean read GetNUMCONIsNull write SetNUMCONIsNull;
    property OldNUMCON : Integer read GetOldNUMCONValue;
    property OldNUMCONIsNull : Boolean read GetOldNUMCONIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IInformeRefGenericaDelta }
  IInformeRefGenericaDelta = interface(IInformeRefGenerica)
  ['{2C849E6E-A572-4480-8371-0767BFC76D53}']
    { Property getters and setters }
    function GetOldCODCENTROValue : String;
    function GetOldCENTROValue : String;
    function GetOldCODVENDEDORValue : String;
    function GetOldVENDEDORValue : String;
    function GetOldFECHAValue : DateTime;
    function GetOldNUMTALONValue : String;
    function GetOldCANTIDADValue : String;
    function GetOldVALTOTValue : Float;

    { Properties }
    property OldCODCENTRO : String read GetOldCODCENTROValue;
    property OldCENTRO : String read GetOldCENTROValue;
    property OldCODVENDEDOR : String read GetOldCODVENDEDORValue;
    property OldVENDEDOR : String read GetOldVENDEDORValue;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldNUMTALON : String read GetOldNUMTALONValue;
    property OldCANTIDAD : String read GetOldCANTIDADValue;
    property OldVALTOT : Float read GetOldVALTOTValue;
  end;

  { TInformeRefGenericaBusinessProcessorRules }
  TInformeRefGenericaBusinessProcessorRules = class(TDABusinessProcessorRules, IInformeRefGenerica, IInformeRefGenericaDelta)
  private
  protected
    { Property getters and setters }
    function GetCODCENTROValue: String; virtual;
    function GetCODCENTROIsNull: Boolean; virtual;
    function GetOldCODCENTROValue: String; virtual;
    function GetOldCODCENTROIsNull: Boolean; virtual;
    procedure SetCODCENTROValue(const aValue: String); virtual;
    procedure SetCODCENTROIsNull(const aValue: Boolean); virtual;
    function GetCENTROValue: String; virtual;
    function GetCENTROIsNull: Boolean; virtual;
    function GetOldCENTROValue: String; virtual;
    function GetOldCENTROIsNull: Boolean; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    procedure SetCENTROIsNull(const aValue: Boolean); virtual;
    function GetCODVENDEDORValue: String; virtual;
    function GetCODVENDEDORIsNull: Boolean; virtual;
    function GetOldCODVENDEDORValue: String; virtual;
    function GetOldCODVENDEDORIsNull: Boolean; virtual;
    procedure SetCODVENDEDORValue(const aValue: String); virtual;
    procedure SetCODVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetVENDEDORValue: String; virtual;
    function GetVENDEDORIsNull: Boolean; virtual;
    function GetOldVENDEDORValue: String; virtual;
    function GetOldVENDEDORIsNull: Boolean; virtual;
    procedure SetVENDEDORValue(const aValue: String); virtual;
    procedure SetVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    function GetFECHAIsNull: Boolean; virtual;
    function GetOldFECHAValue: DateTime; virtual;
    function GetOldFECHAIsNull: Boolean; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetNUMTALONValue: String; virtual;
    function GetNUMTALONIsNull: Boolean; virtual;
    function GetOldNUMTALONValue: String; virtual;
    function GetOldNUMTALONIsNull: Boolean; virtual;
    procedure SetNUMTALONValue(const aValue: String); virtual;
    procedure SetNUMTALONIsNull(const aValue: Boolean); virtual;
    function GetCANTIDADValue: String; virtual;
    function GetCANTIDADIsNull: Boolean; virtual;
    function GetOldCANTIDADValue: String; virtual;
    function GetOldCANTIDADIsNull: Boolean; virtual;
    procedure SetCANTIDADValue(const aValue: String); virtual;
    procedure SetCANTIDADIsNull(const aValue: Boolean); virtual;
    function GetVALTOTValue: Float; virtual;
    function GetVALTOTIsNull: Boolean; virtual;
    function GetOldVALTOTValue: Float; virtual;
    function GetOldVALTOTIsNull: Boolean; virtual;
    procedure SetVALTOTValue(const aValue: Float); virtual;
    procedure SetVALTOTIsNull(const aValue: Boolean); virtual;

    { Properties }
    property CODCENTRO : String read GetCODCENTROValue write SetCODCENTROValue;
    property CODCENTROIsNull : Boolean read GetCODCENTROIsNull write SetCODCENTROIsNull;
    property OldCODCENTRO : String read GetOldCODCENTROValue;
    property OldCODCENTROIsNull : Boolean read GetOldCODCENTROIsNull;
    property CENTRO : String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull : Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property OldCENTRO : String read GetOldCENTROValue;
    property OldCENTROIsNull : Boolean read GetOldCENTROIsNull;
    property CODVENDEDOR : String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property CODVENDEDORIsNull : Boolean read GetCODVENDEDORIsNull write SetCODVENDEDORIsNull;
    property OldCODVENDEDOR : String read GetOldCODVENDEDORValue;
    property OldCODVENDEDORIsNull : Boolean read GetOldCODVENDEDORIsNull;
    property VENDEDOR : String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull : Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property OldVENDEDOR : String read GetOldVENDEDORValue;
    property OldVENDEDORIsNull : Boolean read GetOldVENDEDORIsNull;
    property FECHA : DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull : Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldFECHAIsNull : Boolean read GetOldFECHAIsNull;
    property NUMTALON : String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull : Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property OldNUMTALON : String read GetOldNUMTALONValue;
    property OldNUMTALONIsNull : Boolean read GetOldNUMTALONIsNull;
    property CANTIDAD : String read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull : Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property OldCANTIDAD : String read GetOldCANTIDADValue;
    property OldCANTIDADIsNull : Boolean read GetOldCANTIDADIsNull;
    property VALTOT : Float read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull : Boolean read GetVALTOTIsNull write SetVALTOTIsNull;
    property OldVALTOT : Float read GetOldVALTOTValue;
    property OldVALTOTIsNull : Boolean read GetOldVALTOTIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IGetProductoDelta }
  IGetProductoDelta = interface(IGetProducto)
  ['{1E633156-754C-4296-B146-EB2952CA6084}']
    { Property getters and setters }
    function GetOldCODIGO_BARRAValue : String;
    function GetOldCOR_PRODUTOValue : String;
    function GetOldDESC_PRODUTOValue : String;
    function GetOldPRODUTOValue : String;
    function GetOldGRADEValue : String;

    { Properties }
    property OldCODIGO_BARRA : String read GetOldCODIGO_BARRAValue;
    property OldCOR_PRODUTO : String read GetOldCOR_PRODUTOValue;
    property OldDESC_PRODUTO : String read GetOldDESC_PRODUTOValue;
    property OldPRODUTO : String read GetOldPRODUTOValue;
    property OldGRADE : String read GetOldGRADEValue;
  end;

  { TGetProductoBusinessProcessorRules }
  TGetProductoBusinessProcessorRules = class(TDABusinessProcessorRules, IGetProducto, IGetProductoDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGO_BARRAValue: String; virtual;
    function GetCODIGO_BARRAIsNull: Boolean; virtual;
    function GetOldCODIGO_BARRAValue: String; virtual;
    function GetOldCODIGO_BARRAIsNull: Boolean; virtual;
    procedure SetCODIGO_BARRAValue(const aValue: String); virtual;
    procedure SetCODIGO_BARRAIsNull(const aValue: Boolean); virtual;
    function GetCOR_PRODUTOValue: String; virtual;
    function GetCOR_PRODUTOIsNull: Boolean; virtual;
    function GetOldCOR_PRODUTOValue: String; virtual;
    function GetOldCOR_PRODUTOIsNull: Boolean; virtual;
    procedure SetCOR_PRODUTOValue(const aValue: String); virtual;
    procedure SetCOR_PRODUTOIsNull(const aValue: Boolean); virtual;
    function GetDESC_PRODUTOValue: String; virtual;
    function GetDESC_PRODUTOIsNull: Boolean; virtual;
    function GetOldDESC_PRODUTOValue: String; virtual;
    function GetOldDESC_PRODUTOIsNull: Boolean; virtual;
    procedure SetDESC_PRODUTOValue(const aValue: String); virtual;
    procedure SetDESC_PRODUTOIsNull(const aValue: Boolean); virtual;
    function GetPRODUTOValue: String; virtual;
    function GetPRODUTOIsNull: Boolean; virtual;
    function GetOldPRODUTOValue: String; virtual;
    function GetOldPRODUTOIsNull: Boolean; virtual;
    procedure SetPRODUTOValue(const aValue: String); virtual;
    procedure SetPRODUTOIsNull(const aValue: Boolean); virtual;
    function GetGRADEValue: String; virtual;
    function GetGRADEIsNull: Boolean; virtual;
    function GetOldGRADEValue: String; virtual;
    function GetOldGRADEIsNull: Boolean; virtual;
    procedure SetGRADEValue(const aValue: String); virtual;
    procedure SetGRADEIsNull(const aValue: Boolean); virtual;

    { Properties }
    property CODIGO_BARRA : String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property CODIGO_BARRAIsNull : Boolean read GetCODIGO_BARRAIsNull write SetCODIGO_BARRAIsNull;
    property OldCODIGO_BARRA : String read GetOldCODIGO_BARRAValue;
    property OldCODIGO_BARRAIsNull : Boolean read GetOldCODIGO_BARRAIsNull;
    property COR_PRODUTO : String read GetCOR_PRODUTOValue write SetCOR_PRODUTOValue;
    property COR_PRODUTOIsNull : Boolean read GetCOR_PRODUTOIsNull write SetCOR_PRODUTOIsNull;
    property OldCOR_PRODUTO : String read GetOldCOR_PRODUTOValue;
    property OldCOR_PRODUTOIsNull : Boolean read GetOldCOR_PRODUTOIsNull;
    property DESC_PRODUTO : String read GetDESC_PRODUTOValue write SetDESC_PRODUTOValue;
    property DESC_PRODUTOIsNull : Boolean read GetDESC_PRODUTOIsNull write SetDESC_PRODUTOIsNull;
    property OldDESC_PRODUTO : String read GetOldDESC_PRODUTOValue;
    property OldDESC_PRODUTOIsNull : Boolean read GetOldDESC_PRODUTOIsNull;
    property PRODUTO : String read GetPRODUTOValue write SetPRODUTOValue;
    property PRODUTOIsNull : Boolean read GetPRODUTOIsNull write SetPRODUTOIsNull;
    property OldPRODUTO : String read GetOldPRODUTOValue;
    property OldPRODUTOIsNull : Boolean read GetOldPRODUTOIsNull;
    property GRADE : String read GetGRADEValue write SetGRADEValue;
    property GRADEIsNull : Boolean read GetGRADEIsNull write SetGRADEIsNull;
    property OldGRADE : String read GetOldGRADEValue;
    property OldGRADEIsNull : Boolean read GetOldGRADEIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IReferenciaGenericaDelta }
  IReferenciaGenericaDelta = interface(IReferenciaGenerica)
  ['{E5A5D9F4-735D-4217-A484-35A87F318EAE}']
    { Property getters and setters }
    function GetOldNUMINFValue : String;
    function GetOldCLAVE1Value : Float;
    function GetOldCLAVE2Value : Integer;
    function GetOldCLAVE3Value : Integer;
    function GetOldNUMCONValue : Integer;
    function GetOldFECHAValue : DateTime;
    function GetOldCODCENTROValue : String;
    function GetOldCENTROValue : String;
    function GetOldCODVENDEDORValue : String;
    function GetOldVENDEDORValue : String;
    function GetOldNUMTALONValue : String;
    function GetOldCODIGO_BARRAValue : String;
    function GetOldCODIGOValue : String;
    function GetOldPRODUCTOValue : String;
    function GetOldCOLORValue : String;
    function GetOldTALLAValue : String;
    function GetOldVTAPROCESOValue : Float;
    function GetOldVTAFINALValue : Float;
    function GetOldVTATERMValue : Float;
    function GetOldVALTOTValue : Float;
    function GetOldESTADOValue : String;
    function GetOldFECHACAMBIOValue : DateTime;

    { Properties }
    property OldNUMINF : String read GetOldNUMINFValue;
    property OldCLAVE1 : Float read GetOldCLAVE1Value;
    property OldCLAVE2 : Integer read GetOldCLAVE2Value;
    property OldCLAVE3 : Integer read GetOldCLAVE3Value;
    property OldNUMCON : Integer read GetOldNUMCONValue;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldCODCENTRO : String read GetOldCODCENTROValue;
    property OldCENTRO : String read GetOldCENTROValue;
    property OldCODVENDEDOR : String read GetOldCODVENDEDORValue;
    property OldVENDEDOR : String read GetOldVENDEDORValue;
    property OldNUMTALON : String read GetOldNUMTALONValue;
    property OldCODIGO_BARRA : String read GetOldCODIGO_BARRAValue;
    property OldCODIGO : String read GetOldCODIGOValue;
    property OldPRODUCTO : String read GetOldPRODUCTOValue;
    property OldCOLOR : String read GetOldCOLORValue;
    property OldTALLA : String read GetOldTALLAValue;
    property OldVTAPROCESO : Float read GetOldVTAPROCESOValue;
    property OldVTAFINAL : Float read GetOldVTAFINALValue;
    property OldVTATERM : Float read GetOldVTATERMValue;
    property OldVALTOT : Float read GetOldVALTOTValue;
    property OldESTADO : String read GetOldESTADOValue;
    property OldFECHACAMBIO : DateTime read GetOldFECHACAMBIOValue;
  end;

  { TReferenciaGenericaBusinessProcessorRules }
  TReferenciaGenericaBusinessProcessorRules = class(TDABusinessProcessorRules, IReferenciaGenerica, IReferenciaGenericaDelta)
  private
  protected
    { Property getters and setters }
    function GetNUMINFValue: String; virtual;
    function GetNUMINFIsNull: Boolean; virtual;
    function GetOldNUMINFValue: String; virtual;
    function GetOldNUMINFIsNull: Boolean; virtual;
    procedure SetNUMINFValue(const aValue: String); virtual;
    procedure SetNUMINFIsNull(const aValue: Boolean); virtual;
    function GetCLAVE1Value: Float; virtual;
    function GetCLAVE1IsNull: Boolean; virtual;
    function GetOldCLAVE1Value: Float; virtual;
    function GetOldCLAVE1IsNull: Boolean; virtual;
    procedure SetCLAVE1Value(const aValue: Float); virtual;
    procedure SetCLAVE1IsNull(const aValue: Boolean); virtual;
    function GetCLAVE2Value: Integer; virtual;
    function GetCLAVE2IsNull: Boolean; virtual;
    function GetOldCLAVE2Value: Integer; virtual;
    function GetOldCLAVE2IsNull: Boolean; virtual;
    procedure SetCLAVE2Value(const aValue: Integer); virtual;
    procedure SetCLAVE2IsNull(const aValue: Boolean); virtual;
    function GetCLAVE3Value: Integer; virtual;
    function GetCLAVE3IsNull: Boolean; virtual;
    function GetOldCLAVE3Value: Integer; virtual;
    function GetOldCLAVE3IsNull: Boolean; virtual;
    procedure SetCLAVE3Value(const aValue: Integer); virtual;
    procedure SetCLAVE3IsNull(const aValue: Boolean); virtual;
    function GetNUMCONValue: Integer; virtual;
    function GetNUMCONIsNull: Boolean; virtual;
    function GetOldNUMCONValue: Integer; virtual;
    function GetOldNUMCONIsNull: Boolean; virtual;
    procedure SetNUMCONValue(const aValue: Integer); virtual;
    procedure SetNUMCONIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    function GetFECHAIsNull: Boolean; virtual;
    function GetOldFECHAValue: DateTime; virtual;
    function GetOldFECHAIsNull: Boolean; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetCODCENTROValue: String; virtual;
    function GetCODCENTROIsNull: Boolean; virtual;
    function GetOldCODCENTROValue: String; virtual;
    function GetOldCODCENTROIsNull: Boolean; virtual;
    procedure SetCODCENTROValue(const aValue: String); virtual;
    procedure SetCODCENTROIsNull(const aValue: Boolean); virtual;
    function GetCENTROValue: String; virtual;
    function GetCENTROIsNull: Boolean; virtual;
    function GetOldCENTROValue: String; virtual;
    function GetOldCENTROIsNull: Boolean; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    procedure SetCENTROIsNull(const aValue: Boolean); virtual;
    function GetCODVENDEDORValue: String; virtual;
    function GetCODVENDEDORIsNull: Boolean; virtual;
    function GetOldCODVENDEDORValue: String; virtual;
    function GetOldCODVENDEDORIsNull: Boolean; virtual;
    procedure SetCODVENDEDORValue(const aValue: String); virtual;
    procedure SetCODVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetVENDEDORValue: String; virtual;
    function GetVENDEDORIsNull: Boolean; virtual;
    function GetOldVENDEDORValue: String; virtual;
    function GetOldVENDEDORIsNull: Boolean; virtual;
    procedure SetVENDEDORValue(const aValue: String); virtual;
    procedure SetVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetNUMTALONValue: String; virtual;
    function GetNUMTALONIsNull: Boolean; virtual;
    function GetOldNUMTALONValue: String; virtual;
    function GetOldNUMTALONIsNull: Boolean; virtual;
    procedure SetNUMTALONValue(const aValue: String); virtual;
    procedure SetNUMTALONIsNull(const aValue: Boolean); virtual;
    function GetCODIGO_BARRAValue: String; virtual;
    function GetCODIGO_BARRAIsNull: Boolean; virtual;
    function GetOldCODIGO_BARRAValue: String; virtual;
    function GetOldCODIGO_BARRAIsNull: Boolean; virtual;
    procedure SetCODIGO_BARRAValue(const aValue: String); virtual;
    procedure SetCODIGO_BARRAIsNull(const aValue: Boolean); virtual;
    function GetCODIGOValue: String; virtual;
    function GetCODIGOIsNull: Boolean; virtual;
    function GetOldCODIGOValue: String; virtual;
    function GetOldCODIGOIsNull: Boolean; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    procedure SetCODIGOIsNull(const aValue: Boolean); virtual;
    function GetPRODUCTOValue: String; virtual;
    function GetPRODUCTOIsNull: Boolean; virtual;
    function GetOldPRODUCTOValue: String; virtual;
    function GetOldPRODUCTOIsNull: Boolean; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    procedure SetPRODUCTOIsNull(const aValue: Boolean); virtual;
    function GetCOLORValue: String; virtual;
    function GetCOLORIsNull: Boolean; virtual;
    function GetOldCOLORValue: String; virtual;
    function GetOldCOLORIsNull: Boolean; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    procedure SetCOLORIsNull(const aValue: Boolean); virtual;
    function GetTALLAValue: String; virtual;
    function GetTALLAIsNull: Boolean; virtual;
    function GetOldTALLAValue: String; virtual;
    function GetOldTALLAIsNull: Boolean; virtual;
    procedure SetTALLAValue(const aValue: String); virtual;
    procedure SetTALLAIsNull(const aValue: Boolean); virtual;
    function GetVTAPROCESOValue: Float; virtual;
    function GetVTAPROCESOIsNull: Boolean; virtual;
    function GetOldVTAPROCESOValue: Float; virtual;
    function GetOldVTAPROCESOIsNull: Boolean; virtual;
    procedure SetVTAPROCESOValue(const aValue: Float); virtual;
    procedure SetVTAPROCESOIsNull(const aValue: Boolean); virtual;
    function GetVTAFINALValue: Float; virtual;
    function GetVTAFINALIsNull: Boolean; virtual;
    function GetOldVTAFINALValue: Float; virtual;
    function GetOldVTAFINALIsNull: Boolean; virtual;
    procedure SetVTAFINALValue(const aValue: Float); virtual;
    procedure SetVTAFINALIsNull(const aValue: Boolean); virtual;
    function GetVTATERMValue: Float; virtual;
    function GetVTATERMIsNull: Boolean; virtual;
    function GetOldVTATERMValue: Float; virtual;
    function GetOldVTATERMIsNull: Boolean; virtual;
    procedure SetVTATERMValue(const aValue: Float); virtual;
    procedure SetVTATERMIsNull(const aValue: Boolean); virtual;
    function GetVALTOTValue: Float; virtual;
    function GetVALTOTIsNull: Boolean; virtual;
    function GetOldVALTOTValue: Float; virtual;
    function GetOldVALTOTIsNull: Boolean; virtual;
    procedure SetVALTOTValue(const aValue: Float); virtual;
    procedure SetVALTOTIsNull(const aValue: Boolean); virtual;
    function GetESTADOValue: String; virtual;
    function GetESTADOIsNull: Boolean; virtual;
    function GetOldESTADOValue: String; virtual;
    function GetOldESTADOIsNull: Boolean; virtual;
    procedure SetESTADOValue(const aValue: String); virtual;
    procedure SetESTADOIsNull(const aValue: Boolean); virtual;
    function GetFECHACAMBIOValue: DateTime; virtual;
    function GetFECHACAMBIOIsNull: Boolean; virtual;
    function GetOldFECHACAMBIOValue: DateTime; virtual;
    function GetOldFECHACAMBIOIsNull: Boolean; virtual;
    procedure SetFECHACAMBIOValue(const aValue: DateTime); virtual;
    procedure SetFECHACAMBIOIsNull(const aValue: Boolean); virtual;

    { Properties }
    property NUMINF : String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull : Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property OldNUMINF : String read GetOldNUMINFValue;
    property OldNUMINFIsNull : Boolean read GetOldNUMINFIsNull;
    property CLAVE1 : Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull : Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property OldCLAVE1 : Float read GetOldCLAVE1Value;
    property OldCLAVE1IsNull : Boolean read GetOldCLAVE1IsNull;
    property CLAVE2 : Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull : Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property OldCLAVE2 : Integer read GetOldCLAVE2Value;
    property OldCLAVE2IsNull : Boolean read GetOldCLAVE2IsNull;
    property CLAVE3 : Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull : Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property OldCLAVE3 : Integer read GetOldCLAVE3Value;
    property OldCLAVE3IsNull : Boolean read GetOldCLAVE3IsNull;
    property NUMCON : Integer read GetNUMCONValue write SetNUMCONValue;
    property NUMCONIsNull : Boolean read GetNUMCONIsNull write SetNUMCONIsNull;
    property OldNUMCON : Integer read GetOldNUMCONValue;
    property OldNUMCONIsNull : Boolean read GetOldNUMCONIsNull;
    property FECHA : DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull : Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldFECHAIsNull : Boolean read GetOldFECHAIsNull;
    property CODCENTRO : String read GetCODCENTROValue write SetCODCENTROValue;
    property CODCENTROIsNull : Boolean read GetCODCENTROIsNull write SetCODCENTROIsNull;
    property OldCODCENTRO : String read GetOldCODCENTROValue;
    property OldCODCENTROIsNull : Boolean read GetOldCODCENTROIsNull;
    property CENTRO : String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull : Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property OldCENTRO : String read GetOldCENTROValue;
    property OldCENTROIsNull : Boolean read GetOldCENTROIsNull;
    property CODVENDEDOR : String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property CODVENDEDORIsNull : Boolean read GetCODVENDEDORIsNull write SetCODVENDEDORIsNull;
    property OldCODVENDEDOR : String read GetOldCODVENDEDORValue;
    property OldCODVENDEDORIsNull : Boolean read GetOldCODVENDEDORIsNull;
    property VENDEDOR : String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull : Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property OldVENDEDOR : String read GetOldVENDEDORValue;
    property OldVENDEDORIsNull : Boolean read GetOldVENDEDORIsNull;
    property NUMTALON : String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull : Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property OldNUMTALON : String read GetOldNUMTALONValue;
    property OldNUMTALONIsNull : Boolean read GetOldNUMTALONIsNull;
    property CODIGO_BARRA : String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property CODIGO_BARRAIsNull : Boolean read GetCODIGO_BARRAIsNull write SetCODIGO_BARRAIsNull;
    property OldCODIGO_BARRA : String read GetOldCODIGO_BARRAValue;
    property OldCODIGO_BARRAIsNull : Boolean read GetOldCODIGO_BARRAIsNull;
    property CODIGO : String read GetCODIGOValue write SetCODIGOValue;
    property CODIGOIsNull : Boolean read GetCODIGOIsNull write SetCODIGOIsNull;
    property OldCODIGO : String read GetOldCODIGOValue;
    property OldCODIGOIsNull : Boolean read GetOldCODIGOIsNull;
    property PRODUCTO : String read GetPRODUCTOValue write SetPRODUCTOValue;
    property PRODUCTOIsNull : Boolean read GetPRODUCTOIsNull write SetPRODUCTOIsNull;
    property OldPRODUCTO : String read GetOldPRODUCTOValue;
    property OldPRODUCTOIsNull : Boolean read GetOldPRODUCTOIsNull;
    property COLOR : String read GetCOLORValue write SetCOLORValue;
    property COLORIsNull : Boolean read GetCOLORIsNull write SetCOLORIsNull;
    property OldCOLOR : String read GetOldCOLORValue;
    property OldCOLORIsNull : Boolean read GetOldCOLORIsNull;
    property TALLA : String read GetTALLAValue write SetTALLAValue;
    property TALLAIsNull : Boolean read GetTALLAIsNull write SetTALLAIsNull;
    property OldTALLA : String read GetOldTALLAValue;
    property OldTALLAIsNull : Boolean read GetOldTALLAIsNull;
    property VTAPROCESO : Float read GetVTAPROCESOValue write SetVTAPROCESOValue;
    property VTAPROCESOIsNull : Boolean read GetVTAPROCESOIsNull write SetVTAPROCESOIsNull;
    property OldVTAPROCESO : Float read GetOldVTAPROCESOValue;
    property OldVTAPROCESOIsNull : Boolean read GetOldVTAPROCESOIsNull;
    property VTAFINAL : Float read GetVTAFINALValue write SetVTAFINALValue;
    property VTAFINALIsNull : Boolean read GetVTAFINALIsNull write SetVTAFINALIsNull;
    property OldVTAFINAL : Float read GetOldVTAFINALValue;
    property OldVTAFINALIsNull : Boolean read GetOldVTAFINALIsNull;
    property VTATERM : Float read GetVTATERMValue write SetVTATERMValue;
    property VTATERMIsNull : Boolean read GetVTATERMIsNull write SetVTATERMIsNull;
    property OldVTATERM : Float read GetOldVTATERMValue;
    property OldVTATERMIsNull : Boolean read GetOldVTATERMIsNull;
    property VALTOT : Float read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull : Boolean read GetVALTOTIsNull write SetVALTOTIsNull;
    property OldVALTOT : Float read GetOldVALTOTValue;
    property OldVALTOTIsNull : Boolean read GetOldVALTOTIsNull;
    property ESTADO : String read GetESTADOValue write SetESTADOValue;
    property ESTADOIsNull : Boolean read GetESTADOIsNull write SetESTADOIsNull;
    property OldESTADO : String read GetOldESTADOValue;
    property OldESTADOIsNull : Boolean read GetOldESTADOIsNull;
    property FECHACAMBIO : DateTime read GetFECHACAMBIOValue write SetFECHACAMBIOValue;
    property FECHACAMBIOIsNull : Boolean read GetFECHACAMBIOIsNull write SetFECHACAMBIOIsNull;
    property OldFECHACAMBIO : DateTime read GetOldFECHACAMBIOValue;
    property OldFECHACAMBIOIsNull : Boolean read GetOldFECHACAMBIOIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers, uDAInterfaces;

{ T_ExisteFilaReferenciaGenericaBusinessProcessorRules }
constructor T_ExisteFilaReferenciaGenericaBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor T_ExisteFilaReferenciaGenericaBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetNUMINFValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaNUMINF];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetNUMINFIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaNUMINF]);
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldNUMINFValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaNUMINF];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldNUMINFIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaNUMINF]);
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetNUMINFValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaNUMINF] := aValue;
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetNUMINFIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaNUMINF] := Null;
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetCLAVE1Value: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE1];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetCLAVE1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE1]);
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldCLAVE1Value: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaCLAVE1];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldCLAVE1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaCLAVE1]);
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetCLAVE1Value(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE1] := aValue;
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetCLAVE1IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE1] := Null;
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetCLAVE2Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE2];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetCLAVE2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE2]);
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldCLAVE2Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaCLAVE2];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldCLAVE2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaCLAVE2]);
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetCLAVE2Value(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE2] := aValue;
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetCLAVE2IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE2] := Null;
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetCLAVE3Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE3];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetCLAVE3IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE3]);
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldCLAVE3Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaCLAVE3];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldCLAVE3IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaCLAVE3]);
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetCLAVE3Value(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE3] := aValue;
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetCLAVE3IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaCLAVE3] := Null;
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetNUMCONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaNUMCON];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetNUMCONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaNUMCON]);
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldNUMCONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaNUMCON];
end;

function T_ExisteFilaReferenciaGenericaBusinessProcessorRules.GetOldNUMCONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld__ExisteFilaReferenciaGenericaNUMCON]);
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetNUMCONValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaNUMCON] := aValue;
end;

procedure T_ExisteFilaReferenciaGenericaBusinessProcessorRules.SetNUMCONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld__ExisteFilaReferenciaGenericaNUMCON] := Null;
end;


{ TInformeRefGenericaBusinessProcessorRules }
constructor TInformeRefGenericaBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TInformeRefGenericaBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TInformeRefGenericaBusinessProcessorRules.GetCODCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCODCENTRO];
end;

function TInformeRefGenericaBusinessProcessorRules.GetCODCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCODCENTRO]);
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldCODCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaCODCENTRO];
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldCODCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaCODCENTRO]);
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetCODCENTROValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCODCENTRO] := aValue;
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetCODCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCODCENTRO] := Null;
end;

function TInformeRefGenericaBusinessProcessorRules.GetCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCENTRO];
end;

function TInformeRefGenericaBusinessProcessorRules.GetCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCENTRO]);
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaCENTRO];
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaCENTRO]);
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetCENTROValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCENTRO] := aValue;
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCENTRO] := Null;
end;

function TInformeRefGenericaBusinessProcessorRules.GetCODVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCODVENDEDOR];
end;

function TInformeRefGenericaBusinessProcessorRules.GetCODVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCODVENDEDOR]);
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldCODVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaCODVENDEDOR];
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldCODVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaCODVENDEDOR]);
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetCODVENDEDORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCODVENDEDOR] := aValue;
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetCODVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCODVENDEDOR] := Null;
end;

function TInformeRefGenericaBusinessProcessorRules.GetVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaVENDEDOR];
end;

function TInformeRefGenericaBusinessProcessorRules.GetVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaVENDEDOR]);
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaVENDEDOR];
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaVENDEDOR]);
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetVENDEDORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaVENDEDOR] := aValue;
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaVENDEDOR] := Null;
end;

function TInformeRefGenericaBusinessProcessorRules.GetFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaFECHA];
end;

function TInformeRefGenericaBusinessProcessorRules.GetFECHAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaFECHA]);
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaFECHA];
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldFECHAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaFECHA]);
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetFECHAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaFECHA] := aValue;
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaFECHA] := Null;
end;

function TInformeRefGenericaBusinessProcessorRules.GetNUMTALONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaNUMTALON];
end;

function TInformeRefGenericaBusinessProcessorRules.GetNUMTALONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaNUMTALON]);
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldNUMTALONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaNUMTALON];
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldNUMTALONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaNUMTALON]);
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetNUMTALONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaNUMTALON] := aValue;
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetNUMTALONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaNUMTALON] := Null;
end;

function TInformeRefGenericaBusinessProcessorRules.GetCANTIDADValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCANTIDAD];
end;

function TInformeRefGenericaBusinessProcessorRules.GetCANTIDADIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCANTIDAD]);
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldCANTIDADValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaCANTIDAD];
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldCANTIDADIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaCANTIDAD]);
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetCANTIDADValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCANTIDAD] := aValue;
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetCANTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaCANTIDAD] := Null;
end;

function TInformeRefGenericaBusinessProcessorRules.GetVALTOTValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaVALTOT];
end;

function TInformeRefGenericaBusinessProcessorRules.GetVALTOTIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaVALTOT]);
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldVALTOTValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaVALTOT];
end;

function TInformeRefGenericaBusinessProcessorRules.GetOldVALTOTIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_InformeRefGenericaVALTOT]);
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetVALTOTValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaVALTOT] := aValue;
end;

procedure TInformeRefGenericaBusinessProcessorRules.SetVALTOTIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_InformeRefGenericaVALTOT] := Null;
end;


{ TGetProductoBusinessProcessorRules }
constructor TGetProductoBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TGetProductoBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TGetProductoBusinessProcessorRules.GetCODIGO_BARRAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoCODIGO_BARRA];
end;

function TGetProductoBusinessProcessorRules.GetCODIGO_BARRAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoCODIGO_BARRA]);
end;

function TGetProductoBusinessProcessorRules.GetOldCODIGO_BARRAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoCODIGO_BARRA];
end;

function TGetProductoBusinessProcessorRules.GetOldCODIGO_BARRAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoCODIGO_BARRA]);
end;

procedure TGetProductoBusinessProcessorRules.SetCODIGO_BARRAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoCODIGO_BARRA] := aValue;
end;

procedure TGetProductoBusinessProcessorRules.SetCODIGO_BARRAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoCODIGO_BARRA] := Null;
end;

function TGetProductoBusinessProcessorRules.GetCOR_PRODUTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoCOR_PRODUTO];
end;

function TGetProductoBusinessProcessorRules.GetCOR_PRODUTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoCOR_PRODUTO]);
end;

function TGetProductoBusinessProcessorRules.GetOldCOR_PRODUTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoCOR_PRODUTO];
end;

function TGetProductoBusinessProcessorRules.GetOldCOR_PRODUTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoCOR_PRODUTO]);
end;

procedure TGetProductoBusinessProcessorRules.SetCOR_PRODUTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoCOR_PRODUTO] := aValue;
end;

procedure TGetProductoBusinessProcessorRules.SetCOR_PRODUTOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoCOR_PRODUTO] := Null;
end;

function TGetProductoBusinessProcessorRules.GetDESC_PRODUTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoDESC_PRODUTO];
end;

function TGetProductoBusinessProcessorRules.GetDESC_PRODUTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoDESC_PRODUTO]);
end;

function TGetProductoBusinessProcessorRules.GetOldDESC_PRODUTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoDESC_PRODUTO];
end;

function TGetProductoBusinessProcessorRules.GetOldDESC_PRODUTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoDESC_PRODUTO]);
end;

procedure TGetProductoBusinessProcessorRules.SetDESC_PRODUTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoDESC_PRODUTO] := aValue;
end;

procedure TGetProductoBusinessProcessorRules.SetDESC_PRODUTOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoDESC_PRODUTO] := Null;
end;

function TGetProductoBusinessProcessorRules.GetPRODUTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoPRODUTO];
end;

function TGetProductoBusinessProcessorRules.GetPRODUTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoPRODUTO]);
end;

function TGetProductoBusinessProcessorRules.GetOldPRODUTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoPRODUTO];
end;

function TGetProductoBusinessProcessorRules.GetOldPRODUTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoPRODUTO]);
end;

procedure TGetProductoBusinessProcessorRules.SetPRODUTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoPRODUTO] := aValue;
end;

procedure TGetProductoBusinessProcessorRules.SetPRODUTOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoPRODUTO] := Null;
end;

function TGetProductoBusinessProcessorRules.GetGRADEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoGRADE];
end;

function TGetProductoBusinessProcessorRules.GetGRADEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoGRADE]);
end;

function TGetProductoBusinessProcessorRules.GetOldGRADEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoGRADE];
end;

function TGetProductoBusinessProcessorRules.GetOldGRADEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_GetProductoGRADE]);
end;

procedure TGetProductoBusinessProcessorRules.SetGRADEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoGRADE] := aValue;
end;

procedure TGetProductoBusinessProcessorRules.SetGRADEIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_GetProductoGRADE] := Null;
end;


{ TReferenciaGenericaBusinessProcessorRules }
constructor TReferenciaGenericaBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TReferenciaGenericaBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TReferenciaGenericaBusinessProcessorRules.GetNUMINFValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMINF];
end;

function TReferenciaGenericaBusinessProcessorRules.GetNUMINFIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMINF]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldNUMINFValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaNUMINF];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldNUMINFIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaNUMINF]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetNUMINFValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMINF] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetNUMINFIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMINF] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCLAVE1Value: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE1];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCLAVE1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE1]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCLAVE1Value: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCLAVE1];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCLAVE1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCLAVE1]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCLAVE1Value(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE1] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCLAVE1IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE1] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCLAVE2Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE2];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCLAVE2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE2]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCLAVE2Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCLAVE2];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCLAVE2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCLAVE2]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCLAVE2Value(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE2] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCLAVE2IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE2] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCLAVE3Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE3];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCLAVE3IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE3]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCLAVE3Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCLAVE3];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCLAVE3IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCLAVE3]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCLAVE3Value(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE3] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCLAVE3IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCLAVE3] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetNUMCONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMCON];
end;

function TReferenciaGenericaBusinessProcessorRules.GetNUMCONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMCON]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldNUMCONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaNUMCON];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldNUMCONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaNUMCON]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetNUMCONValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMCON] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetNUMCONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMCON] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaFECHA];
end;

function TReferenciaGenericaBusinessProcessorRules.GetFECHAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaFECHA]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaFECHA];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldFECHAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaFECHA]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetFECHAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaFECHA] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaFECHA] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCODCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODCENTRO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCODCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODCENTRO]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCODCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCODCENTRO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCODCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCODCENTRO]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCODCENTROValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODCENTRO] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCODCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODCENTRO] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCENTRO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCENTRO]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCENTRO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCENTRO]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCENTROValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCENTRO] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCENTRO] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCODVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODVENDEDOR];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCODVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODVENDEDOR]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCODVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCODVENDEDOR];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCODVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCODVENDEDOR]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCODVENDEDORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODVENDEDOR] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCODVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODVENDEDOR] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVENDEDOR];
end;

function TReferenciaGenericaBusinessProcessorRules.GetVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVENDEDOR]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVENDEDOR];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVENDEDOR]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVENDEDORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVENDEDOR] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVENDEDOR] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetNUMTALONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMTALON];
end;

function TReferenciaGenericaBusinessProcessorRules.GetNUMTALONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMTALON]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldNUMTALONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaNUMTALON];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldNUMTALONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaNUMTALON]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetNUMTALONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMTALON] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetNUMTALONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaNUMTALON] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCODIGO_BARRAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODIGO_BARRA];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCODIGO_BARRAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODIGO_BARRA]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCODIGO_BARRAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCODIGO_BARRA];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCODIGO_BARRAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCODIGO_BARRA]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCODIGO_BARRAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODIGO_BARRA] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCODIGO_BARRAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODIGO_BARRA] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCODIGOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODIGO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCODIGOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODIGO]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCODIGOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCODIGO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCODIGOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCODIGO]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCODIGOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODIGO] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCODIGOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCODIGO] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetPRODUCTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaPRODUCTO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetPRODUCTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaPRODUCTO]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldPRODUCTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaPRODUCTO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldPRODUCTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaPRODUCTO]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetPRODUCTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaPRODUCTO] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetPRODUCTOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaPRODUCTO] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetCOLORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCOLOR];
end;

function TReferenciaGenericaBusinessProcessorRules.GetCOLORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCOLOR]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCOLORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCOLOR];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldCOLORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaCOLOR]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCOLORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCOLOR] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetCOLORIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaCOLOR] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetTALLAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaTALLA];
end;

function TReferenciaGenericaBusinessProcessorRules.GetTALLAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaTALLA]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldTALLAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaTALLA];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldTALLAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaTALLA]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetTALLAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaTALLA] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetTALLAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaTALLA] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetVTAPROCESOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTAPROCESO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetVTAPROCESOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTAPROCESO]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVTAPROCESOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVTAPROCESO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVTAPROCESOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVTAPROCESO]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVTAPROCESOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTAPROCESO] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVTAPROCESOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTAPROCESO] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetVTAFINALValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTAFINAL];
end;

function TReferenciaGenericaBusinessProcessorRules.GetVTAFINALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTAFINAL]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVTAFINALValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVTAFINAL];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVTAFINALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVTAFINAL]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVTAFINALValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTAFINAL] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVTAFINALIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTAFINAL] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetVTATERMValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTATERM];
end;

function TReferenciaGenericaBusinessProcessorRules.GetVTATERMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTATERM]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVTATERMValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVTATERM];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVTATERMIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVTATERM]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVTATERMValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTATERM] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVTATERMIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVTATERM] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetVALTOTValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVALTOT];
end;

function TReferenciaGenericaBusinessProcessorRules.GetVALTOTIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVALTOT]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVALTOTValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVALTOT];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldVALTOTIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaVALTOT]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVALTOTValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVALTOT] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetVALTOTIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaVALTOT] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetESTADOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaESTADO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetESTADOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaESTADO]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldESTADOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaESTADO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldESTADOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaESTADO]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetESTADOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaESTADO] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetESTADOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaESTADO] := Null;
end;

function TReferenciaGenericaBusinessProcessorRules.GetFECHACAMBIOValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaFECHACAMBIO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetFECHACAMBIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaFECHACAMBIO]);
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldFECHACAMBIOValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaFECHACAMBIO];
end;

function TReferenciaGenericaBusinessProcessorRules.GetOldFECHACAMBIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciaGenericaFECHACAMBIO]);
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetFECHACAMBIOValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaFECHACAMBIO] := aValue;
end;

procedure TReferenciaGenericaBusinessProcessorRules.SetFECHACAMBIOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciaGenericaFECHACAMBIO] := Null;
end;


initialization
  RegisterBusinessProcessorRules(RID__ExisteFilaReferenciaGenericaDelta, T_ExisteFilaReferenciaGenericaBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_InformeRefGenericaDelta, TInformeRefGenericaBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_GetProductoDelta, TGetProductoBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_ReferenciaGenericaDelta, TReferenciaGenericaBusinessProcessorRules);

end.
